"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _statement = _interopRequireDefault(require("./statement"));

var _json = _interopRequireDefault(require("./json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function encode(string) {
  return Buffer.from(string).toString('base64');
}

function decode(string) {
  return Buffer.from(string, 'base64').toString();
}

function pack(data) {
  return encode(JSON.stringify(data));
}

function unpack(data) {
  return JSON.parse(decode(data));
}

function unscramble(data) {
  return _json["default"].parse(decode(data));
}

var _default = {
  pack: pack,
  unpack: unpack,
  encode: encode,
  decode: decode,
  unscramble: unscramble
};
exports["default"] = _default;