"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _debug = _interopRequireDefault(require("debug"));

var _parameter = _interopRequireDefault(require("../parameter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var errorHandler = function errorHandler(request, response) {
  return function (error) {
    var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 400;
    (0, _debug["default"])('ezs')('Server has caught an error', error);

    if (!response.headersSent) {
      response.setHeader('Content-Type', 'text/plain');
      response.setHeader('Content-Disposition', 'inline');
      response.writeHead(code, {
        'X-Error': _parameter["default"].encode(error.toString())
      });
      response.write(error.toString().split('\n', 1)[0]);
      response.end();
    }
  };
};

var _default = errorHandler;
exports["default"] = _default;