"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _nodeDir = _interopRequireDefault(require("node-dir"));

var _settings = _interopRequireDefault(require("../settings"));

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getInformations = function getInformations(dirPath) {
  return new Promise(function (resolve) {
    var infos = {
      concurrency: _settings["default"].nShards,
      uptime: Date.now() - _constants.STARTED_AT,
      timestamp: Date.now(),
      version: _constants.VERSION,
      daemon: dirPath !== false,
      slave: dirPath === false
    };

    if (!dirPath) {
      return resolve(infos);
    }

    return _nodeDir["default"].files(dirPath, function (err, files) {
      var filenames = err ? [] : files;
      var scripts = filenames.filter(function (f) {
        return f.search(/\.(ini|ezs)$/) > 0;
      }).map(function (f) {
        return f.replace(dirPath, '');
      });
      return resolve(_objectSpread({}, infos, {
        scripts: scripts
      }));
    });
  });
};

var serverInformation = function serverInformation(ezs, serverPath) {
  return function (request, response) {
    getInformations(serverPath).then(function (informations) {
      var responseBody = JSON.stringify(informations);
      var responseHeaders = {
        'Content-Type': 'application/json',
        'Content-Length': Buffer.byteLength(responseBody)
      };
      response.writeHead(200, responseHeaders);
      response.write(responseBody);
      response.end();
    });
  };
};

var _default = serverInformation;
exports["default"] = _default;