"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _debug = _interopRequireDefault(require("debug"));

var _parameter = _interopRequireDefault(require("../parameter"));

var _errorHandler = _interopRequireDefault(require("./errorHandler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var unknownPipeline = function unknownPipeline(ezs) {
  return function (request, response) {
    var headers = request.headers;
    response.setHeader('Content-Encoding', headers['content-encoding'] || 'identity');
    var commands = Object.keys(headers).filter(function (headerKey) {
      return headerKey.indexOf('x-command') === 0;
    }).map(function (headerKey) {
      return parseInt(headerKey.replace('x-command-', ''), 10);
    }).sort(function (x, y) {
      return x - y;
    }).map(function (commandIndex) {
      return _parameter["default"].unscramble(headers["x-command-".concat(commandIndex)]);
    });
    var environment = Object.keys(headers).filter(function (headerKey) {
      return headerKey.indexOf('x-environment') === 0;
    }).map(function (headerKey) {
      return headerKey.replace('x-environment-', '');
    }).map(function (environmentKey) {
      var _Parameter$unpack = _parameter["default"].unpack(headers["x-environment-".concat(environmentKey)]),
          k = _Parameter$unpack.k,
          v = _Parameter$unpack.v;

      return _defineProperty({}, k, v);
    }).reduce(function (prev, cur) {
      return Object.assign(prev, cur);
    }, {});
    (0, _debug["default"])('ezs')("PID ".concat(process.pid, " will execute ").concat(commands.length || 0, " commands with ").concat(Object.keys(environment).length || 0, " global parameters"));
    request.pipe(ezs.uncompress(headers)).pipe(ezs('unpack')).pipe(ezs('ungroup')).pipe(ezs('delegate', {
      commands: commands
    }, environment)).pipe(ezs["catch"]((0, _errorHandler["default"])(request, response))).pipe(ezs(function (input, output) {
      if (!response.headersSent) {
        response.writeHead(200);
      }

      return output.send(input);
    })).pipe(ezs('group')).pipe(ezs('pack')).pipe(ezs.compress(headers)).pipe(response);
    request.resume();
  };
};

var _default = unknownPipeline;
exports["default"] = _default;