"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Shell;

var _autocast = _interopRequireDefault(require("autocast"));

var _lodash = _interopRequireDefault(require("lodash"));

var _notevil = _interopRequireDefault(require("notevil"));

var _mixins = _interopRequireDefault(require("./mixins"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var parse = function parse(chunk, environment) {
  return function (expression) {
    var js = [];
    js.push('_.chain(self).');
    js.push(expression.replace(/([)]\s*->\s*)/g, ').'));
    js.push('.value();');
    var code = js.join('');
    var data = _typeof(chunk) === 'object' ? _lodash["default"].omitBy(chunk, _lodash["default"].isFunction) : chunk;

    _lodash["default"].mixin(_objectSpread({}, _mixins["default"], {
      env: function env(i, p, d) {
        return p ? _lodash["default"].get(environment, p, d) : environment;
      }
    }));

    var result = (0, _notevil["default"])(code, {
      _: _lodash["default"],
      self: data
    });
    return result;
  };
};

var analyse = function analyse(chunk, environment) {
  return function (expression) {
    if (Array.isArray(expression)) {
      return expression.map(analyse(chunk, environment));
    }

    if (!expression || typeof expression !== 'string') {
      return expression;
    }

    if (expression.match(/^[a-zA-Z][a-zA-Z0-9]*[(]/)) {
      return parse(chunk, environment)(expression);
    }

    return (0, _autocast["default"])(expression);
  };
};

function Shell(expression, chunk, environment) {
  if (Array.isArray(expression)) {
    return expression.map(function (item) {
      if (typeof expression !== 'function') {
        return item;
      }

      return item(analyse(chunk, environment));
    });
  }

  if (!expression || !expression.through) {
    return expression;
  }

  return expression.through(analyse(chunk, environment));
}