"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = extract;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Take `Object` and throw each value of fields
 *
 * @param {String} [path] path of field to extract
 * @returns {Object}
 */
function extract(data, feed) {
  if (this.isLast()) {
    return feed.close();
  }

  var keys = this.getParam('path', []);

  if (!Array.isArray(keys)) {
    keys = [keys];
  }

  keys = keys.filter(function (k) {
    return typeof k === 'string';
  });
  var values = keys.map(function (key) {
    return _lodash["default"].get(data, key);
  }).filter(function (val) {
    return val;
  });

  if (values.length === 0) {
    return feed.send(new Error('Nonexistent path.'));
  }

  if (values.length === 1) {
    return feed.send(values[0]);
  }

  return feed.send(values);
}