"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = keep;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Take `Object` and throw the same object but keep only
 * spefici fields
 *
 * @param {String} [path] path of field to keep
 * @returns {Object}
 */
function keep(data, feed) {
  if (this.isLast()) {
    return feed.close();
  }

  var keys = this.getParam('path', []);

  if (!Array.isArray(keys)) {
    keys = [keys];
  }

  var obj = {};
  keys.filter(function (k) {
    return typeof k === 'string';
  }).forEach(function (key) {
    return _lodash["default"].set(obj, key, _lodash["default"].get(data, key));
  });
  return feed.send(obj);
}