"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = validate;

var _util = _interopRequireDefault(require("util"));

var _lodash = _interopRequireDefault(require("lodash"));

var _validatorjs = _interopRequireDefault(require("validatorjs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Take `Object` and throw the same object if all rules passes
 *
 * @param {String} [path] path of the field
 * @param {String} [rule] rule to validate the field
 * @see laravel validtor rules
 * @returns {Object}
 */
function validate(data, feed) {
  if (this.isLast()) {
    return feed.close();
  }

  var path = this.getParam('path', []);
  var paths = Array.isArray(path) ? path : [path];
  var rule = this.getParam('rule', []);
  var rules = Array.isArray(rule) ? rule : [rule];

  var ruless = _lodash["default"].take(rules, paths.length);

  var pathss = _lodash["default"].take(paths, rules.length);

  var assets = _lodash["default"].zipObject(pathss, ruless);

  var validation = new _validatorjs["default"](data, assets);

  if (validation.fails()) {
    return feed.send(new Error(_util["default"].inspect(validation.errors.all())));
  }

  return feed.send(data);
}